# Implement a fake in-memory database interface for demo purpose

from authlib.integrations.starlette_client.apps import StarletteOAuth2App

from .models import User


class Database:
    users: dict[str, User] = {}

    # Last sessions for the user (key: users's subject id (sub))

    async def add_user(
        self, sub: str, user_info: dict, oidc_provider: StarletteOAuth2App
    ) -> User:
        user = User.from_auth(userinfo=user_info, oidc_provider=oidc_provider)
        self.users[sub] = user
        return user

    def get_user(self, sub: str) -> User:
        return self.users[sub]


db = Database()
